aboutsummaryrefslogtreecommitdiff
path: root/app/backup
diff options
context:
space:
mode:
authorrhatto <rhatto@370017ae-e619-0410-ac65-c121f96126d4>2007-12-03 02:31:20 +0000
committerrhatto <rhatto@370017ae-e619-0410-ac65-c121f96126d4>2007-12-03 02:31:20 +0000
commit1f3a42cc5a2ea805eb29e816fdb1d09e2cba16c4 (patch)
tree5dc48d23636addcf991b35f1823ba230cc3fe591 /app/backup
parentc5c8d54bbd00168d7e58e3edfc516bea8bac1395 (diff)
downloadslackbuilds-1f3a42cc5a2ea805eb29e816fdb1d09e2cba16c4.tar.gz
slackbuilds-1f3a42cc5a2ea805eb29e816fdb1d09e2cba16c4.tar.bz2
backupninja: updated to 0.9.5
git-svn-id: svn+slack://slack.fluxo.info/var/svn/slackbuilds@1490 370017ae-e619-0410-ac65-c121f96126d4
Diffstat (limited to 'app/backup')
-rwxr-xr-xapp/backup/backupninja/backupninja.SlackBuild224
1 files changed, 141 insertions, 83 deletions
diff --git a/app/backup/backupninja/backupninja.SlackBuild b/app/backup/backupninja/backupninja.SlackBuild
index fb8e94fd..b3057b4b 100755
--- a/app/backup/backupninja/backupninja.SlackBuild
+++ b/app/backup/backupninja/backupninja.SlackBuild
@@ -1,111 +1,136 @@
#!/bin/bash
#
-# backupninja.SlackBuild is free software; you can redistribute it and/or modify it under the
-# terms of the GNU General Public License as published by the Free Software
-# Foundation; either version 2 of the License, or any later version.
+# backupninja.SlackBuild is free software; you can redistribute
+# it and/or modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of the License,
+# or any later version.
#
-# backupninja.SlackBuild is distributed in the hope that it will be useful, but WITHOUT ANY
-# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-# A PARTICULAR PURPOSE. See the GNU General Public License for more details.
+# backupninja.SlackBuild is distributed in the hope that it will
+# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+# Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307, USA
#
-# slackbuild script for backupninja
-# by rhatto at riseup.net
+# slackbuild for backupninja, by Silvio Rhatto
+# requires:
+# tested: backupninja-0.9.5
#
-CWD="`pwd`"
-
+# Look for slackbuildrc
if [ -f ~/.slackbuildrc ]; then
source ~/.slackbuildrc
elif [ -f /etc/slackbuildrc ]; then
source /etc/slackbuildrc
fi
-# default settings
-PACKAGE="backupninja"
-ARCH="noarch"
-VERSION=${VERSION:=0.9.4}
-BUILD=${BUILD:=8rha}
-SRC_DIR=${SRC:=$CWD}
+# Set variables
+CWD="$(pwd)"
+SRC_NAME="backupninja"
+PKG_NAME="backupninja"
+ARCH=${ARCH:=i486}
+SRC_VERSION=${VERSION:=0.9.5}
+PKG_VERSION="$(echo "$SRC_VERSION" | tr '[[:blank:]-]' '_')"
+BUILD=${BUILD:=1rha}
+SRC_DIR=${SRC_DIR:=$CWD}/$PKG_NAME
TMP=${TMP:=/tmp}
+PKG=${PKG:=$TMP/package-$PKG_NAME}
REPOS=${REPOS:=$TMP}
+PREFIX=${PREFIX:=/usr}
+PKG_WORK="$TMP/$SRC_NAME"
+CONF_OPTIONS=${CONF_OPTIONS:=""}
+NUMJOBS=${NUMJOBS:=""}
+
+# Set system libraries' path and optmization flags based on $ARCH
+LIBDIR="$PREFIX/lib"
+
+if [ "$ARCH" = "i386" ]; then
+ SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+elif [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mcpu=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIR="$PREFIX/lib64"
+fi
-# ------- error codes for createpkg --------------
+# Set error codes (used by createpkg)
ERROR_WGET=31; ERROR_MAKE=32; ERROR_INSTALL=33
ERROR_MD5=34; ERROR_CONF=35; ERROR_HELP=36
ERROR_TAR=37; ERROR_MKPKG=38; ERROR_GPG=39
-ERROR_PATCH=40
+ERROR_PATCH=40; ERROR_VCS=41; ERROR_MKDIR=42
-if [ "$ARCH" == "x86_64" ]; then
- LIBDIR=/usr/lib64
-else
- LIBDIR=/usr/lib
-fi
+# Clean up any leftovers of previous builds
+rm -rf "$PKG_WORK" 2> /dev/null
+rm -rf "$PKG" 2> /dev/null
-RTOOL="wget"
-PACKAGE_EXT="gz"
-SRC="$PACKAGE-$VERSION.tar.$PACKAGE_EXT"
-URL="http://dev.riseup.net/backupninja/download/$SRC"
+# Create directories if necessary
+mkdir -p "$SRC_DIR" || exit $ERROR_MKDIR
+mkdir -p "$PKG" || exit $ERROR_MKDIR
+mkdir -p "$REPOS" || exit $ERROR_MKDIR
+mkdir -p "$PKG_WORK" || exit $ERROR_MKDIR
-SRC_DIR="$SRC_DIR/$PACKAGE"
-mkdir -p $SRC_DIR
-
-if [ "$PACKAGE_EXT" == "bz2" ]; then
- tarflag="j"
-else
- tarflag="z"
-fi
+# Dowload source if necessary
+SRC="$SRC_NAME-$VERSION.tar.gz"
+URL="http://dev.riseup.net/backupninja/download/$SRC"
-if [ "$RTOOL" == "wget" ] && [ ! -f "$SRC_DIR/$SRC" ]; then
+if [ ! -s "$SRC_DIR/$SRC" ] || ! gunzip -t "$SRC_DIR/$SRC" 2> /dev/null; then
wget "$URL" -O "$SRC_DIR/$SRC" || exit $ERROR_WGET
fi
-TMP="$TMP/$PACKAGE"
-rm -rf $TMP
-mkdir -p $TMP
-cd $TMP
-tar xvf$tarflag $SRC_DIR/$SRC || exit $ERROR_TAR
-cd $PACKAGE-$VERSION
+# Untar
+cd "$PKG_WORK"
+tar --no-same-owner --no-same-permissions -xvf "$SRC_DIR/$SRC" || exit $ERROR_TAR
+PKG_SRC=`ls -l | awk '/^d/ { print $8 }'`
+cd "$PKG_SRC"
-if [ -f "$CWD/$PACKAGE-$VERSION.diff" ]; then
- patch -p1 < $CWD/$PACKAGE-$VERSION.diff || exit $ERROR_WGET
-fi
+# Configure
+CFLAGS="$SLKCFLAGS" \
+ CXXFLAGS="$SLKCFLAGS" \
+ ./configure \
+ --prefix="$PREFIX" --libdir="$LIBDIR" $CONF_OPTIONS || exit $ERROR_CONF
-./autogen.sh || exit $ERROR_CONF
-./configure --prefix=/usr --sysconfdir=/etc --libdir=$LIBDIR || exit $ERROR_CONF
-make || exit $ERROR_MAKE
-make DESTDIR=$TMP/package-$PACKAGE install || exit $ERROR_INSTALL
+# Compile
+make $NUMJOBS || exit $ERROR_MAKE
-if [ "$VERSION" == "0.9.4" ]; then
- cp $CWD/rsync $TMP/package-$PACKAGE/usr/share/$PACKAGE/
-fi
+# Install
+make install DESTDIR="$PKG" || exit $ERROR_INSTALL
-# TODO: remove this line if the handler was added to backupninja tree
-cp $CWD/wget $TMP/package-$PACKAGE/usr/share/$PACKAGE/
+# TODO: remove this line as long as the handler is added to the source tree
+cp $CWD/wget $PKG/usr/share/$PKG_NAME/
-rm -rf $TMP/package-$PACKAGE/etc/cron.d
-mkdir $TMP/package-$PACKAGE/etc/cron.hourly
-cp $CWD/backupninja.cron $TMP/package-$PACKAGE/etc/cron.hourly/backupninja
-chmod +x $TMP/package-$PACKAGE/etc/cron.hourly/backupninja
+# Cron tasks
+rm -rf $PKG/etc/cron.d
+mkdir $PKG/etc/cron.hourly
+cp $CWD/backupninja.cron $PKG/etc/cron.hourly/backupninja
+chmod +x $PKG/etc/cron.hourly/backupninja
-CWD="`pwd`"
+# Permissions
+mkdir $PKG/etc/backup.d
+chown -R root.root $PKG/*
+chmod 600 $PKG/etc/backup.d
-cd $TMP/package-$PACKAGE
-mkdir etc/backup.d
-chown -R root.root *
-chmod 600 etc/backup.d
+# Fix config files
+sed -e 's/\/usr\/var\/log/\/var\/log\/backup/g' $PKG/etc/backupninja.conf > $PKG/etc/backupninja.conf.new
+rm $PKG/etc/backupninja.conf
+sed -e 's/\/usr\/var\/log/\/var\/log\/backup/g' $PKG/etc/logrotate.d/backupninja > $PKG/etc/logrotate.d/backupninja.new
+mv $PKG/etc/logrotate.d/backupninja.new $PKG/etc/logrotate.d/backupninja
-sed -e 's/\/usr\/var\/log/\/var\/log\/backup/g' etc/backupninja.conf > etc/backupninja.conf.new
-rm etc/backupninja.conf
-sed -e 's/\/usr\/var\/log/\/var\/log\/backup/g' etc/logrotate.d/backupninja > etc/logrotate.d/backupninja.new
-mv etc/logrotate.d/backupninja.new etc/logrotate.d/backupninja
-mkdir install
-cat << EOF > install/slack-desc
+# Install documentation
+DOCS="AUTHORS COPYING ChangeLog INSTALL NEWS README TODO"
+mkdir -p "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION" || exit $ERROR_MKDIR
+cp -a $DOCS "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION"
+
+# Add package description (slack-desc)
+mkdir -p "$PKG/install" || exit $ERROR_MKDIR
+cat << EODESC > "$PKG/install/slack-desc"
# HOW TO EDIT THIS FILE:
# The "handy ruler" below makes it easier to edit a package description. Line
# up the first '|' above the ':' following the base package name, and the '|'
@@ -113,7 +138,7 @@ cat << EOF > install/slack-desc
# make exactly 11 lines for the formatting to be correct. It's also
# customary to leave one space after the ':'.
- |-----handy-ruler-----------------------------------------------------|
+ |-----handy-ruler--------------------------------------------------|
backupninja: backupninja (a silent flower blossom death strike to lost data)
backupninja:
backupninja: Backupninja allows you to coordinate system backup by dropping a few
@@ -125,21 +150,54 @@ backupninja:
backupninja:
backupninja:
backupninja:
-EOF
-
-# docs
-mkdir -p usr/doc/$PACKAGE-$VERSION
-
-for file in AUTHORS COPYING ChangeLog INSTALL NEWS README TODO; do
- cp $CWD/$file* usr/doc/$PACKAGE-$VERSION/
-done
+EODESC
-# install script
-echo '( if [ ! -f "etc/backupninja.conf" ]; then mv etc/backupninja.conf.new etc/backupninja.conf; fi )' > install/doinst.sh
-
-makepkg -c n -l y $REPOS/$PACKAGE-$VERSION-$ARCH-$BUILD.tgz || exit $ERROR_MKPKG
+# Build the package
+cd "$PKG"
+makepkg -l y -c n "$REPOS/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.tgz" || exit $ERROR_MKPKG
+# Delete source and build directories if requested
if [ "$CLEANUP" == "yes" ]; then
- rm -rf $TMP
+ rm -rf "$PKG_SRC" "$PKG"
fi
+# Configure
+./autogen.sh || exit $ERROR_CONF
+CFLAGS="$SLKCFLAGS" \
+ CXXFLAGS="$SLKCFLAGS" \
+ ./configure \
+ --prefix="$PREFIX" --libdir="$LIBDIR" $CONF_OPTIONS || exit $ERROR_CONF
+
+# Install
+make install DESTDIR="$PKG" || exit $ERROR_INSTALL
+
+# TODO: remove this line as long as the handler is added to the source tree
+cp $CWD/wget $PKG/usr/share/$PKG_NAME/
+
+# Cron tasks
+rm -rf $PKG/etc/cron.d
+mkdir $PKG/etc/cron.hourly
+cp $CWD/backupninja.cron $PKG/etc/cron.hourly/backupninja
+chmod +x $PKG/etc/cron.hourly/backupninja
+
+# Permissions
+mkdir $PKG/etc/backup.d
+chown -R root.root $PKG/*
+chmod 600 $PKG/etc/backup.d
+
+# Fix config files
+sed -e 's/\/usr\/var\/log/\/var\/log\/backup/g' $PKG/etc/backupninja.conf > $PKG/etc/backupninja.conf.new
+rm $PKG/etc/backupninja.conf
+sed -e 's/\/usr\/var\/log/\/var\/log\/backup/g' $PKG/etc/logrotate.d/backupninja > $PKG/etc/logrotate.d/backupninja.new
+mv $PKG/etc/logrotate.d/backupninja.new $PKG/etc/logrotate.d/backupninja
+backupninja: backupninja (a silent flower blossom death strike to lost data)
+backupninja:
+backupninja: Backupninja allows you to coordinate system backup by dropping a few
+backupninja: simple configuration files into /etc/backup.d/. Most programs you
+backupninja: might use for making backups don't have their own configuration file
+backupninja: format. Backupninja provides a centralized way to configure and
+backupninja: schedule many different backup utilities.
+backupninja:
+backupninja:
+backupninja:
+backupninja: